-------------------------------------------------------------------------------
-- system_stub.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system_stub is
  port (
    fpga_0_RS232_Uart_1_RX_pin : in std_logic;
    fpga_0_RS232_Uart_1_TX_pin : out std_logic;
    fpga_0_net_gnd_pin : out std_logic;
    fpga_0_net_gnd_1_pin : out std_logic;
    fpga_0_net_gnd_2_pin : out std_logic;
    fpga_0_net_gnd_3_pin : out std_logic;
    fpga_0_net_gnd_4_pin : out std_logic;
    fpga_0_net_gnd_5_pin : out std_logic;
    fpga_0_net_gnd_6_pin : out std_logic;
    sys_clk_pin : in std_logic;
    sys_rst_pin : in std_logic;
    Sda_decoder : inout std_logic;
    Scl_decoder : inout std_logic;
    vid_dec_reset_in : in std_logic;
    YCrCb_in : in std_logic_vector(9 downto 2);
    PIXEL_CLOCK : out std_logic;
    LLC_CLOCK : in std_logic;
    H_SYNC_Z : out std_logic;
    V_SYNC_Z : out std_logic;
    BLANK_Z : out std_logic;
    COMP_SYNC : out std_logic;
    RESET_VDEC1_Z : out std_logic;
    VDEC1_OE_Z : out std_logic;
    VDEC1_PWRDN_Z : out std_logic;
    R : out std_logic_vector(7 downto 0);
    G : out std_logic_vector(7 downto 0);
    B : out std_logic_vector(7 downto 0);
    bs_wrapper_0_LED1_out_pin : out std_logic;
    bs_wrapper_0_LED2_out_pin : out std_logic
  );
end system_stub;

architecture STRUCTURE of system_stub is

  component system is
    port (
      fpga_0_RS232_Uart_1_RX_pin : in std_logic;
      fpga_0_RS232_Uart_1_TX_pin : out std_logic;
      fpga_0_net_gnd_pin : out std_logic;
      fpga_0_net_gnd_1_pin : out std_logic;
      fpga_0_net_gnd_2_pin : out std_logic;
      fpga_0_net_gnd_3_pin : out std_logic;
      fpga_0_net_gnd_4_pin : out std_logic;
      fpga_0_net_gnd_5_pin : out std_logic;
      fpga_0_net_gnd_6_pin : out std_logic;
      sys_clk_pin : in std_logic;
      sys_rst_pin : in std_logic;
      Sda_decoder : inout std_logic;
      Scl_decoder : inout std_logic;
      vid_dec_reset_in : in std_logic;
      YCrCb_in : in std_logic_vector(9 downto 2);
      PIXEL_CLOCK : out std_logic;
      LLC_CLOCK : in std_logic;
      H_SYNC_Z : out std_logic;
      V_SYNC_Z : out std_logic;
      BLANK_Z : out std_logic;
      COMP_SYNC : out std_logic;
      RESET_VDEC1_Z : out std_logic;
      VDEC1_OE_Z : out std_logic;
      VDEC1_PWRDN_Z : out std_logic;
      R : out std_logic_vector(7 downto 0);
      G : out std_logic_vector(7 downto 0);
      B : out std_logic_vector(7 downto 0);
      bs_wrapper_0_LED1_out_pin : out std_logic;
      bs_wrapper_0_LED2_out_pin : out std_logic
    );
  end component;

begin

  system_i : system
    port map (
      fpga_0_RS232_Uart_1_RX_pin => fpga_0_RS232_Uart_1_RX_pin,
      fpga_0_RS232_Uart_1_TX_pin => fpga_0_RS232_Uart_1_TX_pin,
      fpga_0_net_gnd_pin => fpga_0_net_gnd_pin,
      fpga_0_net_gnd_1_pin => fpga_0_net_gnd_1_pin,
      fpga_0_net_gnd_2_pin => fpga_0_net_gnd_2_pin,
      fpga_0_net_gnd_3_pin => fpga_0_net_gnd_3_pin,
      fpga_0_net_gnd_4_pin => fpga_0_net_gnd_4_pin,
      fpga_0_net_gnd_5_pin => fpga_0_net_gnd_5_pin,
      fpga_0_net_gnd_6_pin => fpga_0_net_gnd_6_pin,
      sys_clk_pin => sys_clk_pin,
      sys_rst_pin => sys_rst_pin,
      Sda_decoder => Sda_decoder,
      Scl_decoder => Scl_decoder,
      vid_dec_reset_in => vid_dec_reset_in,
      YCrCb_in => YCrCb_in,
      PIXEL_CLOCK => PIXEL_CLOCK,
      LLC_CLOCK => LLC_CLOCK,
      H_SYNC_Z => H_SYNC_Z,
      V_SYNC_Z => V_SYNC_Z,
      BLANK_Z => BLANK_Z,
      COMP_SYNC => COMP_SYNC,
      RESET_VDEC1_Z => RESET_VDEC1_Z,
      VDEC1_OE_Z => VDEC1_OE_Z,
      VDEC1_PWRDN_Z => VDEC1_PWRDN_Z,
      R => R,
      G => G,
      B => B,
      bs_wrapper_0_LED1_out_pin => bs_wrapper_0_LED1_out_pin,
      bs_wrapper_0_LED2_out_pin => bs_wrapper_0_LED2_out_pin
    );

end architecture STRUCTURE;

