//takes the black screen flag as input and checks if time until next black screen is
// a multiple of 15s
module ad_detect(
clk,
rst,
BS_found,
LED2_pulse_15,
LED2_pulse_30,
LED2_pulse_45,
LED2_pulse_60
);

input clk,rst,BS_found;
output LED2_pulse_15,LED2_pulse_30,LED2_pulse_45,LED2_pulse_60; //output ad length flags


//reg LED1_pulse;
reg LED2_pulsestart_15;
reg LED2_pulsestart_30;
reg LED2_pulsestart_45;
reg LED2_pulsestart_60;

reg [1:0] pState;
reg [1:0] nState;
reg spacecounter_enable, spacecounter_reset;
reg check1, check2, check3, check4;
reg [31:0] spacecounter;


assign LED2_pulse_15 = LED2_pulsestart_15 ;
assign LED2_pulse_30 = LED2_pulsestart_30;
assign LED2_pulse_45 = LED2_pulsestart_45;
assign LED2_pulse_60 = LED2_pulsestart_60;

parameter reset = 2'b00;
parameter S1 = 2'b01;
parameter S2 = 2'b10;
parameter S3 = 2'b11;


//parameter [31:0] threshold = 32'h50;
//parameter [31:0] base = 32'h708;

//time threshold = 1 second
parameter [31:0] threshold = 32'h19BFCC0;

//time base = 15s
parameter [31:0] base = 32'h1823CF40;

//output and next state logic
always@(BS_found)
begin
			LED2_pulsestart_15 = 0;
			LED2_pulsestart_30 = 0;
			LED2_pulsestart_45 = 0;
			LED2_pulsestart_60 = 0;
			spacecounter_reset = 0;
			spacecounter_enable = 0;
      case(pState)
          reset: begin
						spacecounter_reset = 1;
						if(BS_found)
							nState = S1;
						else
							nState = reset;
          end
          
				S1: begin
					spacecounter_reset = 1;
					//spacecounter_enable = 1;
					if(BS_found)
						nState = S1;
					else
						nState = S2;
					end
					
				S2: begin
						spacecounter_enable = 1;
						if (BS_found)
							if (check1 | check2 | check3 | check4)
								nState = S3;
							else
								nState = S1;
						else
							nState = S2;
						end
				
				S3: begin
						//LED1_pulse = 1;
						if (check1)
							LED2_pulsestart_15 = 1;
						else if (check2)
							LED2_pulsestart_30 = 1;
						else if (check3)
							LED2_pulsestart_45 = 1;
						else if (check4)
							LED2_pulsestart_60 = 1;
						spacecounter_reset = 1;
						//spacecounter_enable = 1;
						if (BS_found)
							nState = S1;
						else
							nState = S2;
					end
				default:nState=reset;
				
     endcase
              
   end
   
   always@(posedge clk or posedge rst)
   begin
       if(rst)
          pState=reset;
        else
        pState=nState;
    end
    
    //datapath spacecounter
    always @(posedge clk)
    begin
           if(spacecounter_reset)
              spacecounter={31'h0};
           else if(spacecounter_enable)
              spacecounter=spacecounter+1;
    end
    
    //check bit logic
    //base=15s 
    //2*base=30s
    //3*base=45s
    //4*base=60s
    always @(*)
    begin
       if(spacecounter > base-threshold & spacecounter < base+threshold)
		  begin
			check1=1;
			check2=0;
			check3=0;
			check4=0;
		  end
       else if (spacecounter > 2*base-threshold & spacecounter < 2*base+threshold)
			begin
				check1=0;
				check2=1;
				check3=0;
				check4=0;
			end
		  else if (spacecounter > 3*base-threshold & spacecounter < 3*base+threshold)
			begin
				check1=0;
				check2=0;
				check3=1;
				check4=0;
			end
		  else if (spacecounter > 4*base-threshold & spacecounter < 4*base+threshold)
			begin
				check1=0;
				check2=0;
				check3=0;
				check4=1;
				end
		  else
			begin
				check1=0;
				check2=0;
				check3=0;
				check4=0;
			end	  
    end
          
    
endmodule