//module takes an input pluse of width 1/27000000s and outputs a pulse of 1sec 
module pulsegen(
clk,
rst,
signal_in,
pulse_out
);

input clk,rst,signal_in;
output pulse_out;

reg pulse;
reg pState, nState;
reg en_counter, rst_counter;
reg check;
reg [25:0] counter;

assign pulse_out = pulse;

//two possible states
//wait for input pulse
parameter reset = 1'b0;
//keep output high until 1sec expires
parameter found = 1'b1;

//output and next state logic
always@(*)
begin
      pulse=1;
      en_counter=0;
      rst_counter=0; 

      case(pState)
          reset: begin
              rst_counter=1;
              if(signal_in) nState=found;
              else nState=reset;
          end
          
          found: begin
                pulse=0;
                en_counter=1;
                if(!check) nState=found;
                else       nState=reset;
            end
          default:nState=reset;
     endcase
              
   end
   
   always@(posedge clk or posedge rst)
   begin
       if(rst)
          pState=reset;
        else
        pState=nState;
    end
    
//datapath counter
    always @(posedge clk)
    begin
           if(rst_counter)
              counter={26'b00000000000000000000000000};
           else if(en_counter)
              counter=counter+1;
    end
    
  	
    //1100110111111110011000000 * 1/27000000 = 1 second
    always @(*)
    begin
       if(counter>26'b01100110111111110011000000)
          check=1;
        else
        check=0;
    end
          
    
endmodule