//-----------------------------------------------------------------------------
// video_capture_0_wrapper.v
//-----------------------------------------------------------------------------

module video_capture_0_wrapper
  (
    YCrCb_in,
    LLC_CLOCK,
    PIXEL_CLOCK,
    R,
    G,
    B,
    H_SYNC_Z,
    V_SYNC_Z,
    BLANK_Z,
    COMP_SYNC,
    RESET_VDEC1_Z,
    VDEC1_OE_Z,
    VDEC1_PWRDN_Z,
    system_dcm_locked,
    FSL_S_Clk,
    FSL_S_Read,
    FSL_S_Data,
    FSL_S_Control,
    FSL_S_Exists,
    FSL_M_Clk,
    FSL_M_Write,
    FSL_M_Data,
    FSL_M_Control,
    FSL_M_Full
  );
  input [9:2] YCrCb_in;
  input LLC_CLOCK;
  output PIXEL_CLOCK;
  output [7:0] R;
  output [7:0] G;
  output [7:0] B;
  output H_SYNC_Z;
  output V_SYNC_Z;
  output BLANK_Z;
  output COMP_SYNC;
  output RESET_VDEC1_Z;
  output VDEC1_OE_Z;
  output VDEC1_PWRDN_Z;
  input system_dcm_locked;
  output FSL_S_Clk;
  output FSL_S_Read;
  input [0:31] FSL_S_Data;
  input FSL_S_Control;
  input FSL_S_Exists;
  output FSL_M_Clk;
  output FSL_M_Write;
  output [0:31] FSL_M_Data;
  output FSL_M_Control;
  input FSL_M_Full;

  video_capture
    video_capture_0 (
      .YCrCb_in ( YCrCb_in ),
      .LLC_CLOCK ( LLC_CLOCK ),
      .PIXEL_CLOCK ( PIXEL_CLOCK ),
      .R ( R ),
      .G ( G ),
      .B ( B ),
      .H_SYNC_Z ( H_SYNC_Z ),
      .V_SYNC_Z ( V_SYNC_Z ),
      .BLANK_Z ( BLANK_Z ),
      .COMP_SYNC ( COMP_SYNC ),
      .RESET_VDEC1_Z ( RESET_VDEC1_Z ),
      .VDEC1_OE_Z ( VDEC1_OE_Z ),
      .VDEC1_PWRDN_Z ( VDEC1_PWRDN_Z ),
      .system_dcm_locked ( system_dcm_locked ),
      .FSL_S_Clk ( FSL_S_Clk ),
      .FSL_S_Read ( FSL_S_Read ),
      .FSL_S_Data ( FSL_S_Data ),
      .FSL_S_Control ( FSL_S_Control ),
      .FSL_S_Exists ( FSL_S_Exists ),
      .FSL_M_Clk ( FSL_M_Clk ),
      .FSL_M_Write ( FSL_M_Write ),
      .FSL_M_Data ( FSL_M_Data ),
      .FSL_M_Control ( FSL_M_Control ),
      .FSL_M_Full ( FSL_M_Full )
    );

endmodule

// synthesis attribute x_core_info of video_capture_0_wrapper is video_capture_v1_01_b;

