//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//     (c) Copyright 2005 Xilinx, Inc.
//     All rights reserved.
//
/*
-------------------------------------------------------------------------------
   Title      : VIDEO CAPTURE FROM THE VDEC1 DAUGHTER BOARD FOR THE XUP-V2Pro
   Project    : XUP-V2Pro 
-------------------------------------------------------------------------------

   File       : PIPE_LINE_DELAY.v
   Company    : Xilinx, Inc.
   Created    : 2004/07/22
   Last Update: 2005/01/20
   Copyright  : (c) Xilinx Inc, 2005
-------------------------------------------------------------------------------
   Uses       : 
-------------------------------------------------------------------------------
   Used by    : VIDEO_CAPTURE.v
-------------------------------------------------------------------------------
  Description: This module aligns the sync and blank signals with the video data.

-------------------------------------------------------------------------------
*/

module PIPE_LINE_DELAY
(
clk,
rst,
hsync_in,
vsync_in,
blank_in,
comp_sync_in,
hsync_out,
vsync_out,
blank_out,
comp_sync_out
);


input 	clk, rst, hsync_in, vsync_in, blank_in, comp_sync_in;
output 	hsync_out;
output   vsync_out;
output 	blank_out;
output   comp_sync_out;

reg [3:0] pipe0;
reg [3:0] pipe1;
reg [3:0] pipe2;
reg [3:0] pipe3;
reg [3:0] pipe4;

//wire hsync_out, vsync_out, blank_out, comp_sync_out;
assign hsync_out = pipe4[0];
assign vsync_out = pipe4[1];
assign blank_out = pipe4[2];
assign comp_sync_out = pipe4[3];



always @ (posedge clk or posedge rst) begin
	if (rst) begin
		pipe0 <= 4'b0000;
		pipe1 <= 4'b0000;
		pipe2 <= 4'b0000;
		pipe2 <= 4'b0000;
		pipe3 <= 4'b0000;
		pipe4 <= 4'b0000;
		end
	else begin
		pipe0[0] <= hsync_in;
		pipe0[1] <= vsync_in;
		pipe0[2] <= blank_in;
		pipe0[3] <= comp_sync_in;

		pipe1[3:0] <= pipe0[3:0];
		pipe2[3:0] <= pipe1[3:0];
		pipe3[3:0] <= pipe2[3:0];
		pipe4[3:0] <= pipe3[3:0];
		end
	end	endmodule
