module ad_detect(
clk,
rst,
BS_found,
LED1_pulsestart,
LED2_pulsestart
);

input clk,rst,BS_found;
output	LED1_pulsestart,LED2_pulsestart;

reg LED1_pulse;
reg LED2_pulse;
reg [1:0] pState;
reg [1:0] nState;
reg spacecounter_enable, spacecounter_reset;
reg check;
reg [31:0] spacecounter;

assign LED1_pulsestart = LED1_pulse;
assign LED2_pulsestart = LED2_pulse;

parameter reset = 2'b00;
parameter S1 = 2'b01;
parameter S2 = 2'b10;
parameter S3 = 2'b11;
//parameter [31:0] threshold = 32'h50;
//parameter [31:0] base = 32'h708;
parameter [31:0] threshold = 32'h19BFCC0;
parameter [31:0] base = 32'h1823CF40;

always@(*)
begin
      case(pState)
          reset: begin
						LED1_pulse = 0;
						LED2_pulse = 0;
						spacecounter_reset = 1;
						spacecounter_enable = 0;
						if(BS_found)
							nState = S1;
						else
							nState = reset;
          end
          
				S1: begin
					LED1_pulse = 1;
					LED2_pulse = 0;
					spacecounter_reset = 1;
					spacecounter_enable = 1;
					if(BS_found)
						nState = S1;
					else
						nState = S2;
					end
					
				S2: begin
						LED1_pulse = 0;
						LED2_pulse = 0;
						spacecounter_reset = 0;
						spacecounter_enable = 1;
						if (BS_found)
							if (check)
								nState = S3;
							else
								nState = S1;
						else
							nState = S2;
						end
				
				S3: begin
						LED1_pulse = 1;
						LED2_pulse = 1;
						spacecounter_reset = 1;
						spacecounter_enable = 1;
						if (BS_found)
							nState = S3;
						else
							nState = S1;
					end
				default:nState=reset;
				
     endcase
              
   end
   
   always@(posedge clk or posedge rst)
   begin
       if(rst)
          pState=reset;
        else
        pState=nState;
    end
    
    always @(posedge clk)
    begin
           if(spacecounter_reset)
              spacecounter={31'h0};
           else if(spacecounter_enable)
              spacecounter=spacecounter+1;
    end
    
    //(counter>26'b11001101111111100110000000)
    //26'b00000000000000000000000111)
	 //1100110111111110011000000
    always @(*)
    begin
       if((spacecounter > base-threshold & spacecounter < base+threshold) | (spacecounter > 2*base-threshold & spacecounter < 2*base+threshold) | (spacecounter > 3*base-threshold & spacecounter < 3*base+threshold) | (spacecounter > 4*base-threshold & spacecounter < 4*base+threshold))
          check=1;
        else
        check=0;
    end
          
    
endmodule