module bs_wrapper(
clk,
rst,
v_sync,
blanking,
R,
G,
B,
LED1_out,
LED2_out
);

input clk;
input rst;
input v_sync;
input blanking;
input [7:0] R,G,B;
output LED1_out;
output LED2_out;

wire clk_27,bs_flag_in, LED1_wire, LED2_wire;

bs_detect DETECTOR(
.clk (clk_27),
.rst (rst),
.blanking_in (blanking),
.v_sync_in (v_sync),
.bs_flag_out(bs_flag_in),
.R_in(R),
.G_in(G),
.B_in(B)
);


ad_detect AD_DECTECTOR(
.clk (clk_27),
.rst (rst),
.BS_found (bs_flag_in),
.LED1_pulsestart (LED1_wire),
.LED2_pulsestart (LED2_wire)
);


pulsegen PULSE1(
.clk (clk_27),
.rst (rst),
.signal_in (LED1_wire),
.pulse_out(LED1_out)
);

pulsegen PULSE2(
.clk (clk_27),
.rst (rst),
.signal_in (LED2_wire),
.pulse_out(LED2_out)
);


IBUFG CLKBUF (
//.O  (llc_clock_i),
.O (clk_27),
.I  (clk)
);

endmodule
