module pulsegen(
clk,
rst,
signal_in,
pulse_out
);

input clk,rst,signal_in;
output pulse_out;

reg pulse;
reg pState, nState;
reg en_counter, rst_counter;
reg check;
reg [25:0] counter;

assign pulse_out = pulse;

parameter reset = 1'b0;
parameter found = 1'b1;

always@(*)
begin
      pulse=1;
      en_counter=0;
      rst_counter=0; 
      case(pState)
          reset: begin
              rst_counter=1;
              if(signal_in) nState=found;
              else nState=reset;
          end
          
          found: begin
                pulse=0;
                en_counter=1;
                if(!check) nState=found;
                else       nState=reset;
            end
          default:nState=reset;
     endcase
              
   end
   
   always@(posedge clk or posedge rst)
   begin
       if(rst)
          pState=reset;
        else
        pState=nState;
    end
    
    always @(posedge clk)
    begin
           if(rst_counter)
              counter={26'b00000000000000000000000000};
           else if(en_counter)
              counter=counter+1;
    end
    
    //(counter>26'b11001101111111100110000000)
    //26'b00000000000000000000000111)
	 //1100110111111110011000000
    always @(*)
    begin
       if(counter>26'b01100110111111110011000000)
          check=1;
        else
        check=0;
    end
          
    
endmodule