//
//
//
//  digilent video decoder expansion board
//
//





#include <xbasic_types.h>
#include <xparameters.h>

#include <xi2c_l.h>



#define GPO_REG_OFFSET 0x124

//#define DECODER_ADDR 0x21  //Read: 0x43, Write: 0x42
#define DECODER_ADDR 0x20 //Read: 0x41, Write: 0x40




#define SEND_CNT 3
#define RECV_CNT 3

struct VideoModule {
  Xuint8 addr;
  Xuint8 config_val;
  Xuint8 actual_val;
};




#define DECODER_SVID_CONFIG_CNT 17
void configDecoder_svid(Xuint8 device);
struct VideoModule decoder_svid[] = { 
  { 0x00, 0x06, 0 },
  { 0x15, 0x00, 0 },
  { 0x27, 0x58, 0 },
  { 0x3a, 0x12, 0 },
  { 0x50, 0x04, 0 },
  { 0x0e, 0x80, 0 },
  { 0x50, 0x20, 0 },
  { 0x52, 0x18, 0 }, 
  { 0x58, 0xed, 0 },
  { 0x77, 0xc5, 0 },
  { 0x7c, 0x93, 0 },
  { 0x7d, 0x00, 0 },
  { 0xd0, 0x48, 0 },
  { 0xd5, 0xa0, 0 },
  { 0xd7, 0xea, 0 },
  { 0xe4, 0x3e, 0 },
  { 0xea, 0x0f, 0 }, 
  { 0x0e, 0x00, 0 } };


#define DECODER_COMP_CONFIG_CNT 18
void configDecoder_comp(Xuint8 device);
struct VideoModule decoder_comp[] = { 
  { 0x00, 0x04, 0 },
  { 0x15, 0x00, 0 },
  { 0x17, 0x41, 0 },
  { 0x27, 0x58, 0 },
  { 0x3a, 0x16, 0 }, 
  { 0x50, 0x04, 0 },
  { 0x0e, 0x80, 0 },
  { 0x50, 0x20, 0 },
  { 0x52, 0x18, 0 }, 
  { 0x58, 0xed, 0 },
  { 0x77, 0xc5, 0 },
  { 0x7c, 0x93, 0 },
  { 0x7d, 0x00, 0 },
  { 0xd0, 0x48, 0 },
  { 0xd5, 0xa0, 0 },
  { 0xd7, 0xea, 0 },
  { 0xe4, 0x3e, 0 },
  { 0xea, 0x0f, 0 }, 
  { 0x0e, 0x00, 0 } };


#define DECODER_CMPNT_CONFIG_CNT 13
void configDecoder_cmpnt(Xuint8 device);
struct VideoModule decoder_cmpnt[] = { 
  { 0x00, 0x0a, 0 },
  { 0x27, 0xd8, 0 },
  { 0x50, 0x04, 0 },
  { 0x0e, 0x80, 0 },
  { 0x52, 0x18, 0 }, 
  { 0x58, 0xed, 0 },
  { 0x77, 0xc5, 0 },
  { 0x7c, 0x93, 0 },
  { 0x7d, 0x00, 0 },
  { 0xd0, 0x48, 0 },
  { 0xd5, 0xa0, 0 },
  { 0xe4, 0x3e, 0 },
  { 0x0e, 0x00, 0 } };


 void printStatus(unsigned int BaseAddress);

int main() {
  Xuint8 start_addr = 0;
  Xuint8 send_data[SEND_CNT] = {0};
  Xuint32 send_cnt;
  Xuint8 recv_data[RECV_CNT] = {0};
  Xuint32 recv_cnt;
  Xuint8 i;
    recv_cnt = 0;
    //print("Detecting Video Decoder...\t");
    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
    recv_cnt = XI2c_RSRecv(XPAR_I2C_BASEADDR, DECODER_ADDR, start_addr, 
			   recv_data, 1);
    //if( recv_cnt != 1 )
      //print("No device detected!\r\n");
    //else {
      //print("Decoder detected!\r\n");
      //configDecoder_svid(0);
	  configDecoder_comp(0);
	  //configDecoder_cmpnt(0);
    //}
  //print("\r\nTest Complete!\r\n\r\n");
} // end main()


void configDecoder_comp(Xuint8 device) 
{
  Xuint16 send_cnt, i;
  Xuint8 send_data[2] = {0};
  Xuint8 success = 1;
  send_cnt = 2;
  //print("  Configuring Decoder...\t");
  for( i = 0; i < DECODER_COMP_CONFIG_CNT; i++ )
   {

    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
    send_data[0] = decoder_comp[i].addr;

    send_data[1] = decoder_comp[i].config_val;

    send_cnt = XI2c_Send(XPAR_I2C_BASEADDR, DECODER_ADDR, send_data, 2);

    if( send_cnt != 2 ) 
	 {
      //xil_print("Error writing to address %02x\r\n", decoder_comp[i].addr);
      success = 0;
      break;
     }
   }

  if( success )
    //print("SUCCESS!\r\n");



 if( success )
 {
    //print("Verifying Configuration...\t");
    for( i = 0; i < DECODER_COMP_CONFIG_CNT; i++ )
	 {
     XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
     XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
     send_cnt = XI2c_RSRecv(XPAR_I2C_BASEADDR, DECODER_ADDR, decoder_comp[i].addr, (Xuint8*) &decoder_comp[i].actual_val, 1);

	 }// end for

    for( i = 0; i < DECODER_COMP_CONFIG_CNT; i++ )
	 {
      if( decoder_comp[i].config_val != decoder_comp[i].actual_val )
	   {
	    //print("FAILED!\r\n");
	    //xil_print("   - Address 0x%02x, Expected 0x%02x, Read 0x%02x\r\n", 
		//decoder_comp[i].addr, decoder_comp[i].config_val, 
		//decoder_comp[i].actual_val);
	    //success = 0;
	    //break;
       }// end if
   }// end for
  } // end if
   // if( success )
      //print("SUCCESS!\r\n");

} // end configDecoder()

void configDecoder_svid(Xuint8 device) 
{
  Xuint16 send_cnt, i;
  Xuint8 send_data[2] = {0};
  Xuint8 success = 1;
  send_cnt = 2;
  //print("  Configuring Decoder for svideo...\t");
  for( i = 0; i < DECODER_SVID_CONFIG_CNT; i++ )
   {

    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
    send_data[0] = decoder_svid[i].addr;

    send_data[1] = decoder_svid[i].config_val;

    send_cnt = XI2c_Send(XPAR_I2C_BASEADDR, DECODER_ADDR, send_data, 2);

    if( send_cnt != 2 ) 
	 {
      //xil_print("Error writing to address %02x\r\n", decoder_svid[i].addr);
      success = 0;
      break;
     }
   }

  //if( success )
    //print("SUCCESS!\r\n");



 if( success )
 {
    //print("Verifying Configuration...\t");
    for( i = 0; i < DECODER_SVID_CONFIG_CNT; i++ )
	 {
     XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
     XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
     send_cnt = XI2c_RSRecv(XPAR_I2C_BASEADDR, DECODER_ADDR, decoder_svid[i].addr, (Xuint8*) &decoder_svid[i].actual_val, 1);

	 }// end for

    for( i = 0; i < DECODER_SVID_CONFIG_CNT; i++ )
	 {
      if( decoder_svid[i].config_val != decoder_svid[i].actual_val )
	   {
	    //print("FAILED!\r\n");
	    //xil_print("   - Address 0x%02x, Expected 0x%02x, Read 0x%02x\r\n", 
		//decoder_svid[i].addr, decoder_svid[i].config_val, 
		//decoder_svid[i].actual_val);
	    //success = 0;
	    //break;
       }// end if
   }// end for
  } // end if
   // if( success )
      //print("SUCCESS!\r\n");

} // end configDecoder()

void configDecoder_cmpnt(Xuint8 device) 
{
  Xuint16 send_cnt, i;
  Xuint8 send_data[2] = {0};
  Xuint8 success = 1;
  send_cnt = 2;
  //print("  Configuring Decoder for svideo...\t");
  for( i = 0; i < DECODER_CMPNT_CONFIG_CNT; i++ )
   {


    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
    XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
    send_data[0] = decoder_cmpnt[i].addr;

    send_data[1] = decoder_cmpnt[i].config_val;

    send_cnt = XI2c_Send(XPAR_I2C_BASEADDR, DECODER_ADDR, send_data, 2);

    if( send_cnt != 2 ) 
	 {
      //xil_print("Error writing to address %02x\r\n", decoder_cmpnt[i].addr);
      success = 0;
      break;
     }
   }

  //if( success )
    //print("SUCCESS!\r\n");



 if( success )
 {
    //print("Verifying Configuration...\t");
    for( i = 0; i < DECODER_CMPNT_CONFIG_CNT; i++ )
	 {
     XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 1);
     XI2c_mWriteReg(XPAR_I2C_BASEADDR, GPO_REG_OFFSET, 0);
     send_cnt = XI2c_RSRecv(XPAR_I2C_BASEADDR, DECODER_ADDR, decoder_cmpnt[i].addr, (Xuint8*) &decoder_cmpnt[i].actual_val, 1);

	 }// end for

    for( i = 0; i < DECODER_CMPNT_CONFIG_CNT; i++ )
	 {
      if( decoder_cmpnt[i].config_val != decoder_cmpnt[i].actual_val )
	   {
	    //print("FAILED!\r\n");
	    //xil_print("   - Address 0x%02x, Expected 0x%02x, Read 0x%02x\r\n", 
		//decoder_cmpnt[i].addr, decoder_cmpnt[i].config_val, 
		//decoder_cmpnt[i].actual_val);
	    //success = 0;
	    //break;
       }// end if
   }// end for
  } // end if
    //if( success )
      //print("SUCCESS!\r\n");

} // end configDecoder()
